/*
 * keyb.h
 *
 * Keyboard header
 */

#ifndef INCLUDED_KEYB_H
#define INCLUDED_KEYB_H


/*
 * Definitions
 */ 

#define KEYB_KEYP_ESC       0x01
#define KEYB_KEYP_UP        0x48
#define KEYB_KEYP_DOWN      0x50
#define KEYB_KEYP_LEFT      0x4b
#define KEYB_KEYP_RIGHT     0x4d
#define KEYB_KEYP_P         0x19
#define KEYB_KEYP_S         0x1f
#define KEYB_KEYP_X         0x2d
#define KEYB_KEYP_A         0x1e
#define KEYB_KEYP_Z         0x2c
#define KEYB_KEYP_COMMA     0x33
#define KEYB_KEYP_DOT       0x34
#define KEYB_KEYP_NUMPAD5   0x4c

#define KEYB_KEYR_ESC       (KEYB_KEYP_ESC | 0x80)
#define KEYB_KEYR_UP        (KEYB_KEYP_UP | 0x80)
#define KEYB_KEYR_DOWN      (KEYB_KEYP_DOWN | 0x80)
#define KEYB_KEYR_LEFT      (KEYB_KEYP_LEFT | 0x80)
#define KEYB_KEYR_RIGHT     (KEYB_KEYP_RIGHT | 0x80)
#define KEYB_KEYR_P         (KEYB_KEYP_P | 0x80)
#define KEYB_KEYR_S         (KEYB_KEYP_S | 0x80)
#define KEYB_KEYR_X         (KEYB_KEYP_X | 0x80)
#define KEYB_KEYR_A         (KEYB_KEYP_A | 0x80)
#define KEYB_KEYR_Z         (KEYB_KEYP_Z | 0x80)
#define KEYB_KEYR_COMMA     (KEYB_KEYP_COMMA | 0x80)
#define KEYB_KEYR_DOT       (KEYB_KEYP_DOT | 0x80)
#define KEYB_KEYR_NUMPAD5   (KEYB_KEP_NUMPAD5 | 0x80)


/*
 * Functions
 */

extern UINT8    KeybGetKey();
extern BOOL     KeybInit();
extern void     KeybDeinit();


#endif  // INCLUDED_KEYB_H
