/*
 * scrshot.c
 *
 * BMP screen shot code
 */

#include <pc.h>
#include <stdio.h>
#include "types.h"


void ScreenShot(UINT8 *vidbuf, INT32 xres, INT32 yres)
{
    FILE    *fp;
    INT32   i, j;
    UINT8   r, g, b;

    if ((fp = fopen("shot.bmp", "wb")) == NULL)
        return;

	/*
     * Write the BMP file header
     */

	fwrite("BM", sizeof(char), 2, fp);
    i = 14 + 40 + 256*4 + xres*yres*1;  // size = 14 + 40 + 256colors*4 + xres*yres*8bpp
    fwrite(&i, sizeof(UINT32), 1, fp);
    fwrite("\0\0\0\0", sizeof(unsigned char), 4, fp);
    i = 40 + 14 + 256*4;            // image offset
    fwrite(&i, sizeof(UINT32), 1, fp);
    i = 40;
    fwrite(&i, sizeof(UINT32), 1, fp);
    i = xres;                       // image width in pixels
    fwrite(&i, sizeof(UINT32), 1, fp);
    i = yres;                       // image height in pixels
    fwrite(&i, sizeof(UINT32), 1, fp);
    fwrite("\1\0", sizeof(UINT8), 2, fp);
    i = 8;                          // bits per pixel
    fwrite(&i, sizeof(UINT16), 1, fp);
    fwrite("\0\0\0\0\0\0\0\0", sizeof(UINT8), 8, fp);
    fwrite("\0\0\0\0\0\0\0\0", sizeof(UINT8), 8, fp);
    i = 256;                        // number of colors in palette
    fwrite(&i, sizeof(UINT32), 1, fp);
    fwrite("\0\0\0\0", sizeof(UINT8), 4, fp);

    /*
     * Write palette
     */

    outportb(0x3c6, 0xff);      // palette mask register
    for (i = 0; i < 256; i++)
    {
        outportb(0x3c7, i);     // which color we want to read
        r = inportb(0x3c9);
        g = inportb(0x3c9);
        b = inportb(0x3c9);
        r <<= 2;
        g <<= 2;
        b <<= 2;
        fwrite(&b, sizeof(UINT8), 1, fp);
        fwrite(&g, sizeof(UINT8), 1, fp);
        fwrite(&r, sizeof(UINT8), 1, fp);
        fwrite("\0", sizeof(UINT8), 1, fp);
    }

    /*
     * Write the image data bottom-up
     */

    for (i = (yres - 1) * xres; i >= 0; i -= xres)
    {
        for (j = 0; j < xres; j++)
            fwrite(&vidbuf[i + j], sizeof(UINT8), 1, fp);
    }

    fclose(fp);
}
